/*
 * This code is in the public domain; do with it what you wish.
 */

#ifndef _MD5_H_
#define _MD5_H_
#include <stdlib.h>
typedef unsigned char uchar;
typedef unsigned char* ucharp;

#ifdef _WIN32
typedef unsigned long int u_int32_t;
#else
#include <sys/types.h>
#endif

#define MD5_HASHBYTES 16

typedef struct MD5Context {
    u_int32_t buf[4];
    u_int32_t bits[2];
    uchar in[64];
} MD5_CTX;

#ifdef __cplusplus
extern "C" {
#endif
extern void make_digest(ucharp str, ucharp digest);
extern void MD5Init(MD5_CTX *context);
extern void MD5Update(MD5_CTX *context, uchar const *buf, unsigned len);
extern void MD5Final(uchar digest[], MD5_CTX *context);
extern void MD5Transform(u_int32_t buf[], u_int32_t const in[]);
extern void MD5End(ucharp, ucharp);
#ifdef __cplusplus
}
#endif

#endif /* _MD5_H_ */
